#include "mult.h"
#pragma hdrstop

#include "mult_idenav.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)


TComponent* __fastcall IDEComponentFromPath(AnsiString s)
{ if (s=="") s="Application";
  TComponent *com=NULL;
  while (s!="")
  { AnsiString first=s;
    int i=first.Pos("->");
    if (i==0) s="";
    else
    { first=s.SubString(1,i-1);
      s=s.SubString(i+2,s.Length()-i-1);
    }
    if (first=="Application") com=Application;
    else
    { if (com==NULL) return NULL;
      else
      { TComponent *cd=IDEChildComponentFromString(com,first);
        if (cd==NULL) return NULL;
        else com=cd;
      }
    }
  }
  return com;
}

AnsiString __fastcall StringFromIDEChildComponent(TComponent*com,TComponent*c)
{ AnsiString name=c->Name;
  AnsiString cls=c->ClassName();
  int matches=0;
  bool found=false;
  for (int i=0; i<com->ComponentCount && !found;i++)
  { TComponent *cd=com->Components[i];
    if (cd->Name==name && AnsiString(cd->ClassName())==cls) matches++;
    if (cd==c) found=true;
  }
  if (!found) matches++;
  return name+"["+cls+"]"+(matches>1?AnsiString(matches):AnsiString(""));
}
TComponent* __fastcall IDEChildComponentFromString(TComponent*com,AnsiString s)
{ AnsiString name="",cls="",sind="";
  char *c=s.c_str();
  while (*c!='[' && *c!=0) {name=name+AnsiString(*c); c++;} if (*c!=0) c++;
  while (*c!=']' && *c!=0) {cls=cls+AnsiString(*c); c++;} if (*c!=0) c++;
  while (*c!=0) {sind=sind+AnsiString(*c); c++;}; if (*c!=0) c++;
  int ind; if (sind=="") ind=1; else ind=sind.ToInt();
  int matches=0;
  for (int i=0; i<com->ComponentCount; i++)
  { TComponent*cd=com->Components[i];
    if (cd->Name==name && AnsiString(cd->ClassName())==cls)
    { matches++;
      if (matches==ind) return cd;
    }
  }
  return NULL;
}










bool __fastcall ClickIDEMenuItem(AnsiString s)
{ TMenuItem *mi=dynamic_cast<TMenuItem*>(IDEComponentFromPath(s));
  if (mi==NULL) return false;
  mi->Click(); return true;
}

bool __fastcall ClickIDEButton(AnsiString s)
{ TButton *btn=dynamic_cast<TButton*>(IDEComponentFromPath(s));
  if (btn==NULL) return false;
  btn->Click(); return true;
}

AnsiString __fastcall GetIDEEditText(AnsiString s)
{ TEdit *ed=dynamic_cast<TEdit*>(IDEComponentFromPath(s));
  if (ed==NULL) return "";
  return ed->Text;
}

bool __fastcall SetIDEEditText(AnsiString s,AnsiString val)
{ TEdit *ed=dynamic_cast<TEdit*>(IDEComponentFromPath(s));
  if (ed==NULL) return false;
  ed->Text=val; return true;
}

bool __fastcall GetIDECheckBox(AnsiString s)
{ TCheckBox *cb=dynamic_cast<TCheckBox*>(IDEComponentFromPath(s));
  if (cb==NULL) return false;
  return cb->Checked;
}

// Just setting its checked property sometimes isn't enough.
// eg. setting packages check to false in project|options|packages
// changes the visual state of the box but does nothing else.
bool __fastcall SetIDECheckBox(AnsiString s,bool b)
{ TCheckBox *cb=dynamic_cast<TCheckBox*>(IDEComponentFromPath(s));
  if (cb==NULL) return false;
  if (cb->Checked==b) return true;
  SendMessage(cb->Handle,BM_CLICK,0,0);
  if (cb->Checked==b) return true;
  return false;
}

bool __fastcall SetIDEActivePage(AnsiString spc,AnsiString sts)
{ TPageControl *pc=dynamic_cast<TPageControl*>(IDEComponentFromPath(spc));
  TTabSheet *ts=dynamic_cast<TTabSheet*>(IDEComponentFromPath(sts));
  if (pc==NULL || ts==NULL) return false;
  pc->ActivePage=ts; return true;
}


HWND __fastcall AllocateLocalHWnd(WNDPROC wndproc)
{ WNDCLASSEX wcx;
  ZeroMemory(&wcx,sizeof(wcx)); wcx.cbSize=sizeof(wcx);
  BOOL res=GetClassInfoEx(HInstance,"IDEAsynchronousControlWindowClass",&wcx);
  if (!res)
  { ZeroMemory(&wcx,sizeof(wcx));
    wcx.cbSize=sizeof(wcx);
    wcx.style=0;
    wcx.lpfnWndProc=DefWindowProc;
    wcx.cbClsExtra=0;
    wcx.cbWndExtra=0;
    wcx.hInstance=HInstance;
    wcx.hIcon=NULL;
    wcx.hCursor=NULL;
    wcx.hbrBackground=NULL;
    wcx.lpszMenuName=NULL;
    wcx.lpszClassName="IDEAsynchronousControlWindowClass";
    wcx.hIconSm=NULL;
    ATOM res=RegisterClassEx(&wcx);
    if (res==NULL) return NULL;
  }
  HWND hwnd=CreateWindowEx(0,"IDEAsynchronousControlWindowClass","IDEAsynchronousControlWindow",0,0,0,0,0,NULL,NULL,HInstance,NULL);
  if (hwnd==NULL) return NULL;
  SetWindowLong(hwnd,GWL_WNDPROC,(LONG)wndproc);
  return hwnd;
}

void __fastcall DeallocateLocalHWnd(HWND hwnd)
{ SetWindowLong(hwnd,GWL_WNDPROC,(LONG)DefWindowProc);
  DestroyWindow(hwnd);
}





HWND IDEAsynchronousControlWindow=NULL;
TNotifyEvent IDEAsynchronousNotifyEvent=NULL;

LRESULT CALLBACK IDEAsynchronousControlWindowProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{ LRESULT res=DefWindowProc(hwnd,msg,wParam,lParam);
  if (IDEAsynchronousControlWindow==NULL) return res;
  if (msg!=WM_USER) return res;
  IDEAsynchronousControlWindow=NULL;
  DeallocateLocalHWnd(hwnd);
  TNotifyEvent ne=IDEAsynchronousNotifyEvent;
  IDEAsynchronousNotifyEvent=NULL;
  if (ne!=NULL) ne(NULL);
  return res;
}

bool __fastcall ContinueIDEAsynchronouslyWith(TNotifyEvent ne)
{ if (IDEAsynchronousControlWindow!=NULL) return false;
  IDEAsynchronousNotifyEvent=ne;
  IDEAsynchronousControlWindow=AllocateLocalHWnd(IDEAsynchronousControlWindowProc);
  PostMessage(IDEAsynchronousControlWindow,WM_USER,0,0);
  return true;
}

